#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h> /* ick */
#include <string.h>
#include <mntent.h>
#include <grp.h>

int getfsgid(const char *dir, gid_t *r)
{
	struct stat sa,sb;
	struct mntent *m;
	struct group *grp;
	char *q, *p;
	FILE *fp;
	long int n;

	if (stat(dir, &sa) == -1) return 0;
	if (!(sa.st_mode & S_IFDIR)) return 0;
	if (sa.st_mode & S_ISGID) {
		(*r) = sa.st_gid;
		return 1;
	}
	fp = setmntent("/etc/mtab", "r");
	if (fp) {
		while ((m = getmntent(fp))) {
			if (stat(m->mnt_dir, &sb) == -1) continue;
			if (!S_ISDIR(sb.st_mode)) continue; /* eh... */
			if (sb.st_dev != sa.st_dev) continue;
			if (sb.st_ino != sa.st_ino) continue;
			if (sb.st_rdev != sa.st_rdev) continue;
			if (!m->mnt_opts) continue;
			q = strstr(m->mnt_opts, "gid=");
			if (!q) q = strstr(m->mnt_opts, "group=");
			if (!q) continue;
			q = strchr(q, '='); /* safe; see strstr success */
			q++;
			if (!*q) continue; /* nul? */
			n = strtol(q, &p, 0); /* XXX or 10? */
			if (p && *p && *p != ',' && *p != ';') {
				grp = getgrnam(q);
				if (!grp) continue;
				(*r) = grp->gr_gid;
			} else {
				(*r) = n;
			}
			(void)endmntent(fp);
			return 1;
		}
		(void)endmntent(fp);
	}
	/* still here? */
	(*r) = getegid();
	return 1;
}
